<?php
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

include 'config.php'; // Include your database configuration

// Get POST data
$data = json_decode(file_get_contents("php://input"), true);
$user_id = isset($data['user_id']) ? intval($data['user_id']) : 0; // Cast to integer for security
$amount = isset($data['amount']) ? floatval($data['amount']) : 0; // Cast to float for security
$conn->begin_transaction();

try {
    $query = "
        UPDATE bills 
        SET 
            remain_amount = remain_amount - $amount, 
            total_amount = total_amount + $amount 
        WHERE 
            id = $user_id 
            AND remain_amount > 0
    ";
    
    // Execute the query directly
    if ($conn->query($query) === TRUE) {
        // Commit the transaction
        $conn->commit();
        echo json_encode(["success" => true]);
    } else {
        // Rollback the transaction on failure
        $conn->rollback();
        echo json_encode(["success" => false, "message" => "Payment update failed"]);
    }
} catch (Exception $e) {
    // Rollback the transaction in case of error
    $conn->rollback();
    echo json_encode(["success" => false, "message" => "Error: " . $e->getMessage()]);
} finally {
    $conn->close();
}
