<?php 
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

include 'config.php'; // Include your database configuration

// Create a new bill
if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $input = json_decode(file_get_contents('php://input'), true);

    // Validate input
    if (empty($input['date']) || empty($input['products'])) {
        echo json_encode(['error' => 'Invalid input']);
        http_response_code(400);
        exit;
    }

    // Start a transaction
    $conn->begin_transaction();

    try {
        // Check if the name is null or if the mobile number doesn't exist in the users table
        if (empty($input['name']) || !checkUserExists($conn, $input['mobile'])) {
            // Insert the user data into the users table
            $newname = $input['newname'];
            $mobile = $input['mobile'];
            $address = $input['address'];
            $stmt = $conn->prepare("INSERT INTO users (name, phone, address) VALUES ('$newname', '$mobile', '$address')");
            $stmt->execute();
            $userId = $conn->insert_id; // Get the last inserted user id
        } else {
            // Fetch the user ID based on the mobile number if the user already exists
            $userId = getUserIdByMobile($conn, $input['mobile']);
        }

        // Insert bill data
        $date = $input['date'];
        $newname = $input['newname'];
        $type = $input['type'];
        $billNo = $input['billNo'];
        $address = $input['address'];
        $totalAmount = $input['totalAmount'];
        $gst = $input['gst'];
        $advanceAmount = $input['advanceAmount'];
        $remainAmount = $input['remainAmount'];
        $paymentMethod = $input['paymentMethod'];
        $description = $input['description'];
        $deliveryDate = $input['delivery_date'];

        $stmt = $conn->prepare("INSERT INTO bills (user_id, date, type,name,address, mobile, bill_no, total_amount, gst, advance_amount, remain_amount, p_mode, description, delivery_date) VALUES ('$userId', '$date', '$type','$newname', '$address', '$mobile', '$billNo', '$totalAmount', '$gst', '$advanceAmount', '$remainAmount', '$paymentMethod', '$description', '$deliveryDate')");
        $stmt->execute();
        $billId = $conn->insert_id; // Get the last inserted bill id

        if ($input['type'] != "REPAIR") {
            // Insert products
            foreach ($input['products'] as $product) {
                $productName = $product['productName'];
                $description = $product['description'];
                $quantity = $product['quantity'];
                $discount = $product['discount'];
                $totalPrice = $product['totalPrice'];

                $stmt = $conn->prepare("INSERT INTO bill_products (bill_id, product_id, description, quantity, discount, total_price) VALUES ('$billId', '$productName', '$description', '$quantity', '$discount', '$totalPrice')");
                $stmt->execute();
            }
        }

        // Commit the transaction
        $conn->commit();
        echo json_encode(['success' => true]);

    } catch (Exception $e) {
        // Rollback the transaction on error
        $conn->rollback();
        echo json_encode(['error' => 'Error saving the bill: ' . $e->getMessage()]);
    }

} elseif ($_SERVER['REQUEST_METHOD'] === 'GET') {
    // Fetch bills
    $billsStmt = $conn->prepare("SELECT `id`, `user_id`, `date`, `type`, `mobile`, `bill_no`, `total_amount`, `gst`, `advance_amount`, `remain_amount`, `created_at` FROM `bills` WHERE 1");
    $billsStmt->execute();
    $billsResult = $billsStmt->get_result();
    $bills = $billsResult->fetch_all(MYSQLI_ASSOC);

    // Fetch bill products for each bill
    foreach ($bills as &$bill) {
        $billId = $bill['id'];
        $productsStmt = $conn->prepare("SELECT `id`, `bill_id`, `product_id`, `quantity`, `discount`, `total_price` FROM `bill_products` WHERE bill_id = '$billId'");
        $productsStmt->execute();
        $productsResult = $productsStmt->get_result();
        $bill['products'] = $productsResult->fetch_all(MYSQLI_ASSOC);
    }

    echo json_encode(['bills' => $bills]);
}

// Helper function to check if user exists based on mobile number
function checkUserExists($conn, $mobile) {
    $stmt = $conn->prepare("SELECT id FROM users WHERE phone = '$mobile'");
    $stmt->execute();
    $result = $stmt->get_result();
    return $result->num_rows > 0;
}

// Helper function to get user ID by mobile number
function getUserIdByMobile($conn, $mobile) {
    $stmt = $conn->prepare("SELECT id FROM users WHERE phone = '$mobile'");
    $stmt->execute();
    $result = $stmt->get_result();
    $row = $result->fetch_assoc();
    return $row['id'];
}
