<?php

header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

include "config.php";
date_default_timezone_set("Asia/Kolkata");

$_POST = json_decode(file_get_contents("php://input"), true);

$oid = $_POST['oid'];
$action = $_POST['action'];
$final_order_amount = 0;
$tt = 0;
$coupon = 0;
// Update order status
$sql = "UPDATE `checkout` SET `status`='$action' WHERE `orderid`='$oid'";
$row = mysqli_query($conn, $sql);

if ($row) {
    // If order status updated successfully
    if ($action == "approve") {
        // If action is approval, create token and schedule pickup
        $token = createtoken();
        if ($token) {
            $getOrderItems = "SELECT products.name AS name, 
                                      products.code AS sku, 
                                      `order`.price AS price, 
                                      `order`.qty AS qty 
                               FROM products 
                               INNER JOIN `order` ON `order`.pid = products.id 
                               WHERE `order`.orderid ='$oid'";
            $orderItemsResult = mysqli_query($conn, $getOrderItems);

            $productDetails = []; // Initialize an empty array for order items

            // Loop through the result set to fetch all order items
            while ($orderItem = mysqli_fetch_assoc($orderItemsResult)) {
                $productDetails[] = $orderItem;
            }

            $shippingResponse = scheduleExpressBeesPickup($oid, $token, $productDetails, "normal");
            if ($shippingResponse) {
                // If pickup scheduled successfully, update order details
                updateOrderDetails($oid, $shippingResponse);
                if ($shippingResponse['data']['status'] == true) {
                    echo json_encode(["message" => "radha", "data" => $shippingResponse]);
                } else {
                    echo json_encode(["message" => "invalid", "data" => $shippingResponse]);
                }
            } else {
                echo json_encode(["message" => "Failed to schedule pickup"]);
            }
        } else {
            echo json_encode(["message" => "Failed to create token"]);
        }
    }else if ($action == "reject") {
        $s1 = "SELECT * FROM `checkout` WHERE `orderid`='$oid'";
        $sr = mysqli_query($conn, $s1);
        $sn = mysqli_fetch_array($sr);
        $ctype = $sn['pay_method'];
        if ($ctype != "COD") {
            $token = createtoken();
            if ($token) {
                $shippingResponse = scheduleExpressBeesPickup($oid, $token, [], "return");
                if ($shippingResponse) {
                    // If pickup scheduled successfully, update order details
                    updateOrderDetails($oid, $shippingResponse);
                    if ($shippingResponse['data']['status'] == true) {
                        echo json_encode(["message" => "radha", "data" => $shippingResponse]);
                    } else {
                        echo json_encode(["message" => "invalid", "data" => $shippingResponse]);
                    }
                } else {
                    echo json_encode(["message" => "Failed to schedule pickup"]);
                }
            } else {
                echo json_encode(["message" => "Failed to create token"]);
            }
        } else {
            echo json_encode(["message" => "radha"]);
        }
    } else {
        // If action is not approval
        echo json_encode(["message" => "radha"]);
    }
} else {
    // If failed to update order status
    echo json_encode(["message" => "Failed to update order status"]);
}

// Function to create token
function createtoken()
{
    $data = array(
        'email' => 'shrutinilesh7904@gmail.com', // Replace with your email
        'password' => 'Nilesh@1234' // Replace with your password
    );

    $url = 'https://shipment.xpressbees.com/api/users/login';

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));

    $response = curl_exec($ch);
    $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);

    // if ($httpcode == 200) {
        $responseData = json_decode($response, true);
        return $responseData['data']; // Return the token
    // } else {
    //     return null; // Return null if token retrieval fails
    // }
}

// Function to schedule pickup
function scheduleExpressBeesPickup($oid, $token, $productDetails, $ptype)
{
    global $conn;
    // Fetch order details
    $sql = "SELECT * FROM `checkout` WHERE `orderid`='$oid'";
    $result = mysqli_query($conn, $sql);
    $runn = mysqli_fetch_array($result);
    $name = $runn["name"];
    $ad1 = $runn["ad1"];
    $ad21 = $runn["ad2"];
    $city = $runn["city"];
    $state = $runn["state"];
    $pincode = $runn["pincode"];
    $mobile = $runn["mobile"];
    $total = $runn["total"];
    $coupon = $runn["coupon"];
    $pay_method = $runn["pay_method"];

    $final_order_amount = $pay_method == "COD" ? round($total) - round($coupon) : "0";

    $cc = $pay_method != "COD" ? 0 : $final_order_amount;
    $pp = $pay_method == "COD" ? "cod" : "prepaid";
    
    
    

    $pickupDetails = array(
        'order_number' => $oid,
        'payment_type' => $pp,
        'order_amount' => $final_order_amount,
        'consignee' => array(
            'name' => $name,
            'address' => $ad1,
            'city' => $city,
            'state' => $state,
            'pincode' => $pincode,
            'phone' => $mobile
        ),
        'pickup' => array(
            'warehouse_name' => 'Manglik Gold',
            'name' => 'Manglik Gold',
            'address' => '34/2 Swaminarayan Nagar, Part-2',
            'address_2' => 'Nikol Road',
            'city' => 'Ahmedabad',
            'state' => 'Gujarat',
            'pincode' => '382350',
            'phone' => '7990202540'
        ),
        'order_items' => $productDetails,
        'courier_id' => '',
        'collectable_amount' => $final_order_amount
    );

    $expressBeesApiUrl = 'https://shipment.xpressbees.com/api/shipments2';

    // Make API call to schedule pickup
    $ch = curl_init($expressBeesApiUrl);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($pickupDetails));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
        'Content-Type: application/json',
        'Authorization: Bearer ' . $token
    ));

    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);
    return $responseData; // Return response data
}

// Function to update order details after pickup scheduling
function updateOrderDetails($oid, $shippingResponse)
{
    // Update order details in database
    global $conn;
    $sid = $shippingResponse['data']['shipment_id'];
    $awb = $shippingResponse['data']['awb_number'];
    $label = $shippingResponse['data']['label'];
    $status = $shippingResponse['data']['status'];
    // $status = 'pending';
    $cid = $shippingResponse['data']['courier_id'];

    $sql = "UPDATE `checkout` SET `shipping`='$sid', `awb`='$awb', `c_id`='$cid', `label`='$label' WHERE `orderid`='$oid'";
    $result = mysqli_query($conn, $sql);
}
?>
