<?php
header('Content-Type: application/json; charset=UTF-8');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: POST, GET');
header('Access-Control-Allow-Headers: Access-Control-Allow-Headers, Content-Type, Access-Control-Allow-Methods, Authorization, X-Requested-With');

include 'config.php'; // Include your database configuration

// Query to get users with outstanding payments
$query = "
    SELECT 
        u.id AS user_id,
        u.name AS user_name,
        u.phone,
        b.address,
        b.date,
        b.name AS billname,
        b.mobile AS billmobile,
        b.bill_no,
        b.total_amount,
        b.gst,
        b.description,
        b.type,
        b.delivery_date,
        b.advance_amount,
        b.remain_amount,
        b.p_mode,
        b.id AS bill_id
    FROM users u
    JOIN bills b ON u.id = b.user_id
    WHERE b.remain_amount > 0
";

$result = $conn->query($query);
$outstandingPayments = [];

if ($result->num_rows > 0) {
    // Fetch each bill and associated user
    while ($row = $result->fetch_assoc()) {
        $billId = $row['bill_id'];
        
        // Query to get products for this bill
        $productQuery = "
            SELECT 
                bp.id AS product_id,
                p.name AS product_name,
                bp.quantity,
                bp.discount,
                bp.total_price,
                bp.description
            FROM bill_products bp
            JOIN products p ON bp.product_id = p.id
            WHERE bp.bill_id = $billId
        ";

        
        $productResult = $conn->query($productQuery);
        $products = [];

        if ($productResult->num_rows > 0) {
            // Fetch all products for this bill
            while ($productRow = $productResult->fetch_assoc()) {
                $products[] = $productRow;
            }
        }

        // Add products to the main array
        $row['products'] = $products;
        $outstandingPayments[] = $row;
    }
}

// Output the results as JSON
echo json_encode($outstandingPayments);

// Close the database connection
$conn->close();
