<?php

require '/home/humujnmy/vendor/autoload.php'; // Adjust relative path as needed

use Google\Auth\ApplicationDefaultCredentials;
use Google\Auth\OAuth2;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\RequestException;

function getAccessToken($serviceAccountFilePath) {
    $scopes = ['https://www.googleapis.com/auth/firebase.messaging'];

    // Load the service account credentials
    $jsonKey = json_decode(file_get_contents($serviceAccountFilePath), true);

    // Set up OAuth2 client
    $oauth2 = new OAuth2([
        'audience' => 'https://oauth2.googleapis.com/token',
        'issuer' => $jsonKey['client_email'],
        'subject' => $jsonKey['client_email'],
        'signingAlgorithm' => 'RS256',
        'signingKey' => $jsonKey['private_key'],
        'tokenCredentialUri' => 'https://oauth2.googleapis.com/token',
        'scope' => implode(' ', $scopes),
    ]);

    // Fetch the OAuth 2.0 token
    $token = $oauth2->fetchAuthToken();

    // Return the access token
    return $token['access_token'];
}

function sendNotification($fcmToken, $title, $body,$page) {
    

    $url = 'https://fcm.googleapis.com/v1/projects/manglikgold-c3dc8/messages:send';
$serviceAccountFilePath = '/home/humujnmy/public_html/demo_manglik/DEMO/mobile/web/utils/manglikgold-c3dc8-8e0c119dfbbe.json';
if (!file_exists($serviceAccountFilePath)) {
    // Handle the error or provide a fallback
    echo 'JSON file not found.';
}


// Get OAuth 2.0 access token
$accessToken = getAccessToken($serviceAccountFilePath);
    // Payload for the notification
    $payload = json_encode([
        'message' => [
            'token' => $fcmToken,
            'notification' => [
                'title' => $title,
                'body' => $body,
            ],
            'data' => [
                'action' => $page, // Custom key for click action
                'profile_id' => 'some_value' // Any additional data you want to pass
            ]
        ],
    ]);

    // Set up headers
    $headers = [
        'Authorization' => 'Bearer ' . $accessToken,
        'Content-Type' => 'application/json',
    ];

    // Send the request via Guzzle
    $client = new Client();

    try {
        $response = $client->post($url, [
            'headers' => $headers,
            'body' => $payload,
        ]);

        return $response->getBody()->getContents();
    } catch (RequestException $e) {
        return $e->getMessage();
    }
}

// $token = "f0-3EKqVS7umJ8tJtmH5Ln:APA91bHyWiOeopsPkUSBS9Ri_jTIpk9Q3DP_twNC8IX4nEnNWC5JJ2WoM0kjW_ENtj1vkNJAxAuLuro2iBKFeqR7hoXx3Ky1CNSsI1jEiZYLXDVIY3cffHWhjmBaetKfLXGTTf4E0m7Y";
//  $msg = sendNotification($token,"Yami","dsfv","dhan");
// echo $msg;
?>




