<?php
include('pdf.php');
include('config.php');

function sendPDF($oid) {
    global $conn;

    // Corrected SQL query to fetch the required data
    $sql = "SELECT gb.*, u.name, u.phone, u.g_percent, u.address 
            FROM gold_booking gb 
            JOIN users u ON gb.uid = u.id 
            WHERE gb.oid = '$oid'"; // Corrected to use single quotes around $oid

    $row = mysqli_query($conn, $sql);

    // Check if the query execution was successful
    if (!$row) {
        die("Error: " . mysqli_error($conn));
    }

    $run = mysqli_fetch_assoc($row); // Fetch the data as an associative array

    // Check if any data was returned
    if (!$run) {
        die("Error: No data found for order with ID $oid");
    }

    // Perform calculations based on retrieved data
    $weight = $run['weight'];
    $m_price = $run['m_price'];

    // Calculate metal price
    $metal_price = intval($weight) * intval($m_price);

    // Calculate labour cost (assuming 15% of metal price)
    $labour = $metal_price * 0.15;

    // Calculate GST (assuming 3% of total including labour)
    $total_with_labour = $metal_price + $labour;
    $gst = $total_with_labour * 0.03;

    // Prepare order details for PDF generation
    $orderDetails = [
        'date' => $run['date'],
        'customerName' => $run['name'],
        'orderNo' => $run['oid'],
        'number' => $run['phone'],
        'address' => $run['address'],
        'gst' => $gst,
        'total' => $run['total'],
        'advance' => $run['advance'],
        'mtotal' => $metal_price,
        'labourRate' => $labour,
        'percent' => $run['g_percent'],
        'remain' => $run['total'] - $run['advance'],
        'items' => [
            [
                'itemName' => $run['metal'],
                'pcs' => '1',
                'grossWt' => $weight,
                'netWt' => $weight,
                'metalRate' => $m_price,
                'extraRs' => '', // Add if available
                'labour' => $labour // Include labour cost for the item
            ],
        ]
    ];

    // Generate PDF using the provided function
    $url = createOrderPDF($orderDetails);
    return $url;
}

// Example usage
// $oid = 'MGGOLD20240613243153'; // Replace with the actual order ID
// sendPDF($oid);
?>
